
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>手把手教你ARC——iOS/Mac开发ARC入门和使用 / iVAN</title>

    <meta name="description" content="手把手教你ARC——iOS/Mac开发ARC入门和使用 本文部分实例取自iOS 5 Toturail一书中关于ARC的教程和公开内容,仅用于技术交流和讨论.请不要将本文的部分或全部内容用于商用,谢谢合作. 欢迎转载本文,但是转载请注明本文出处:http://www.onevcat.com/2012/06/arc-hand-by-hand/ 本文适合人群:对iOS开发有一定基础,熟悉iOS开发中内存管理的Reference Counting机制,对ARC机制有听闻很向往但是一直由于种种原因没有使用的童鞋.本文将从ARC机理入手对这个解放广大iOS开发者">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">手把手教你ARC——iOS/Mac开发ARC入门和使用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文部分实例取自iOS 5 Toturail一书中关于ARC的<a href="http://www.raywenderlich.com/5677/beginning-arc-in-ios-5-part-1" rel="external nofollow noreferrer">教程和公开内容</a>，仅用于技术交流和讨论。请不要将本文的部分或全部内容用于商用，谢谢合作。</p>
<p>欢迎转载本文，但是转载请注明本文出处：<a href="http://www.onevcat.com/2012/06/arc-hand-by-hand/" rel="external nofollow noreferrer">http://www.onevcat.com/2012/06/arc-hand-by-hand/</a></p>
<p>本文适合人群：对iOS开发有一定基础，熟悉iOS开发中内存管理的Reference Counting机制，对ARC机制有听闻很向往但是一直由于种种原因没有使用的童鞋。本文将从ARC机理入手对这个解放广大iOS开发者的伟大机制进行一个剖析，并逐步引导你开始使用ARC。一旦习惯ARC，你一定会被它的简洁高效所征服。</p>
<h2>写在开头</h2>
<p>虽然距离WWDC2011和iOS 5已经快一年时间，但是很多开发者并没有利用新方法来提高自己的水平，这点在ARC的使用上非常明显(特别是国内，基本很少见到同行转向ARC)。我曾经询问过一些同行为什么不转向使用ARC，很多人的回答是担心内存管理不受自己控制..其实我个人认为这是对于ARC机制了解不足从而不自信，所导致的对新事物的恐惧。而作为最需要“追赶时髦”的职业，这样的心态将相当不利。谨以此文希望能清楚表述ARC的机理和用法，也希望能够成为现在中文入门教学缺失的补充。</p>
<hr>
<h2>什么是ARC</h2>
<p>Automatic Reference Counting，自动引用计数，即ARC，可以说是WWDC2011和iOS5所引入的最大的变革和最激动人心的变化。ARC是新的LLVM 3.0编译器的一项特性，使用ARC，可以说一举解决了广大iOS开发者所憎恨的手动内存管理的麻烦。</p>
<p>在工程中使用ARC非常简单：只需要像往常那样编写代码，只不过永远不写<code>retain</code>,<code>release</code>和<code>autorelease</code>三个关键字就好～这是ARC的基本原则。当ARC开启时，编译器将自动在代码合适的地方插入<code>retain</code>, <code>release</code>和<code>autorelease</code>，而作为开发者，完全不需要担心编译器会做错（除非开发者自己错用ARC了）。好了，ARC相当简单吧～到此为止，本教程结束。</p>
<p>等等…也许还有其他问题，最严重的问题是“我怎么确定让ARC来管理不会出问题？”或者“用ARC会让程序性能下降吧”。对于ARC不能正处理内存管理的质疑自从ARC出生以来就一直存在，而现在越来越多的代码转向ARC并取得了很好的效果，这证明了ARC是一套有效的简化开发复杂程度的机制，另外通过研究ARC的原理，可以知道使用ARC甚至能提高程序的效率。在接下来将详细解释ARC的运行机理并且提供了一个step-by-step的教程，将非ARC的程序转换为ARC。</p>
<hr>
<h2>ARC工作原理</h2>
<p>手动内存管理的机理大家应该已经非常清楚了，简单来说，只要遵循以下三点就可以在手动内存管理中避免绝大部分的麻烦：</p>
<blockquote><p>如果需要持有一个对象，那么对其发送retain 如果之后不再使用该对象，那么需要对其发送release（或者autorealse） 每一次对retain,alloc或者new的调用，需要对应一次release或autorealse调用</p></blockquote>
<p>初学者可能仅仅只是知道这些规则，但是在实际使用时难免犯错。但是当开发者经常使用手动引用计数 Manual Referecen Counting(MRC)的话，这些规则将逐渐变为本能。你会发现少一个<code>release</code>的代码怎么看怎么别扭，从而减少或者杜绝内存管理的错误。可以说MRC的规则非常简单，但是同时也非常容易出错。往往很小的错误就将引起crash或者OOM之类的严重问题。</p>
<p>在MRC的年代里，为了避免不小心忘写<code>release</code>，Xcode提供了一个很实用的小工具来帮助可能存在的代码问题(Xcode3里默认快捷键Shift+A？不记得了)，可以指出潜在的内存泄露或者过多释放。而ARC在此基础上更进一步：ARC是Objective-C编译器的特性，而不是运行时特性或者垃圾回收机制，ARC所做的只不过是在代码编译时为你自动在合适的位置插入<code>release</code>或<code>autorelease</code>，就如同之前MRC时你所做的那样。因此，至少在效率上ARC机制是不会比MRC弱的，而因为可以在最合适的地方完成引用计数的维护，以及部分优化，使用ARC甚至能比MRC取得更高的运行效率。</p>
<h3>ARC机制</h3>
<p>学习ARC很简单，在MRC时代你需要自己<code>retain</code>一个想要保持的对象，而现在不需要了。现在唯一要做的是用一个指针指向这个对象，只要指针没有被置空，对象就会一直保持在堆上。当将指针指向新值时，原来的对象会被<code>release</code>一次。这对实例变量，synthesize的变量或者局部变量都是适用的。比如</p>
<pre><code>NSString *firstName = self.textField.text;
</code></pre>
<p><code>firstName</code>现在指向NSString对象，这时这个对象（<code>textField</code>的内容字符串）将被hold住。比如用字符串@“OneV"作为例子（虽然实际上不应该用字符串举例子，因为字符串的retainCount规则其实和普通的对象不一样，大家就把它当作一个普通的对象来看吧…），这个时候<code>firstName</code>持有了@"OneV"。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMxLnBuZw==.jpg"></p>
<p>当然，一个对象可以拥有不止一个的持有者（这个类似MRC中的retainCount&gt;1的情况）。在这个例子中显然<code>self.textField.text</code>也是@“OneV"，那么现在有两个指针指向对象@"OneV”(被持有两次，retainCount=2，其实对NSString对象说retainCount是有问题的，不过anyway～就这个意思而已.)。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMyLnBuZw==.jpg"></p>
<p>过了一会儿，也许用户在<code>textField</code>里输入了其他的东西，那么<code>self.textField.text</code>指针显然现在指向了别的字符串，比如@“onevcat"，但是这时候原来的对象已然是存在的，因为还有一个指针<code>firstName</code>持有它。现在指针的指向关系是这样的：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMzLnBuZw==.jpg"></p>
<p>只有当<code>firstName</code>也被设定了新的值，或者是超出了作用范围的空间(比如它是局部变量但是这个方法执行完了或者它是实例变量但是这个实例被销毁了)，那么此时<code>firstName</code>也不再持有@“OneV"，此时不再有指针指向@"OneV"，在ARC下这种状况发生后对象@"OneV"即被销毁，内存释放。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWM0LnBuZw==.jpg"></p>
<p>类似于<code>firstName</code>和<code>self.textField.text</code>这样的指针使用关键字<code>strong</code>进行标志，它意味着只要该指针指向某个对象，那么这个对象就不会被销毁。反过来说，ARC的一个基本规则即是，<strong>只要某个对象被任一<code>strong</code>指针指向，那么它将不会被销毁。如果对象没有被任何strong指针指向，那么就将被销毁</strong>。在默认情况下，所有的实例变量和局部变量都是<code>strong</code>类型的。可以说<code>strong</code>类型的指针在行为上和MRC时代<code>retain</code>的property是比较相似的。</p>
<p>既然有<code>strong</code>，那肯定有<code>weak</code>咯～<code>weak</code>类型的指针也可以指向对象，但是并不会持有该对象。比如：</p>
<pre><code>__weak NSString *weakName = self.textField.text
</code></pre>
<p>得到的指向关系是：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWM1LnBuZw==.jpg"></p>
<p>这里声明了一个<code>weak</code>的指针<code>weakName</code>，它并不持有@“onevcat"。如果<code>self.textField.text</code>的内容发生改变的话，根据之前提到的<strong>"只要某个对象被任一strong指针指向，那么它将不会被销毁。如果对象没有被任何strong指针指向，那么就将被销毁”</strong>原则，此时指向@“onevcat"的指针中没有<code>strong</code>类型的指针，@"onevcat"将被销毁。同时，在ARC机制作用下，所有指向这个对象的<code>weak</code>指针将被置为<code>nil</code>。这个特性相当有用，相信无数的开发者都曾经被指针指向已释放对象所造成的EXC_BAD_ACCESS困扰过，使用ARC以后，不论是<code>strong</code>还是<code>weak</code>类型的指针，都不再会指向一个dealloced的对象，从<strong>根源上解决了意外释放导致的crash</strong>。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWM2LnBuZw==.jpg"></p>
<p>不过在大部分情况下，<code>weak</code>类型的指针可能并不会很常用。比较常见的用法是在两个对象间存在包含关系时：对象1有一个<code>strong</code>指针指向对象2，并持有它，而对象2中只有一个<code>weak</code>指针指回对象1，从而避免了循环持有。一个常见的例子就是oc中常见的delegate设计模式，viewController中有一个<code>strong</code>指针指向它所负责管理的UITableView，而UITableView中的<code>dataSource</code>和<code>delegate</code>指针都是指向viewController的<code>weak</code>指针。可以说，<code>weak</code>指针的行为和MRC时代的<code>assign</code>有一些相似点，但是考虑到<code>weak</code>指针更聪明些（会自动指向nil），因此还是有所不同的。细节的东西我们稍后再说。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWM3LnBuZw==.jpg"></p>
<p>注意类似下面的代码似乎是没有什么意义的：</p>
<pre><code>__weak NSString *str = [[NSString alloc] initWithFormat:…];
NSLog(@"%@",str); //输出是"(null)"
</code></pre>
<p>由于<code>str</code>是<code>weak</code>，它不会持有alloc出来的<code>NSString</code>对象，因此这个对象由于没有有效的<code>strong</code>指针指向，所以在生成的同时就被销毁了。如果我们在Xcode中写了上面的代码，我们应该会得到一个警告，因为无论何时这种情况似乎都是不太可能出现的。你可以把<strong>weak换成</strong>strong来消除警告，或者直接前面什么都不写，因为ARC中默认的指针类型就是<code>strong</code>。</p>
<p>property也可以用<code>strong</code>或<code>weak</code>来标记，简单地把原来写<code>retain</code>和<code>assign</code>的地方替换成<code>strong</code>或者<code>weak</code>就可以了。</p>
<pre><code>@property (nonatomic, strong) NSString *firstName;
@property (nonatomic, weak) id  delegate;
</code></pre>
<p>ARC可以为开发者节省很多代码，使用ARC以后再也不需要关心什么时候<code>retain</code>，什么时候<code>release</code>，但是这并不意味你可以不思考内存管理，你可能需要经常性地问自己这个问题：谁持有这个对象？</p>
<p>比如下面的代码，假设<code>array</code>是一个<code>NSMutableArray</code>并且里面至少有一个对象：</p>
<pre><code>id obj = [array objectAtIndex:0]; 
[array removeObjectAtIndex:0]; 
NSLog(@"%@",obj);
</code></pre>
<p>在MRC时代这几行代码应该就挂掉了，因为<code>array</code>中0号对象被remove以后就被立即销毁了，因此obj指向了一个dealloced的对象，因此在NSLog的时候将出现EXC_BAD_ACCESS。而在ARC中由于obj是<code>strong</code>的，因此它持有了<code>array</code>中的首个对象，<code>array</code>不再是该对象的唯一持有者。即使我们从<code>array</code>中将obj移除了，它也依然被别的指针持有，因此不会被销毁。</p>
<h3>一点提醒</h3>
<p>ARC也有一些缺点，对于初学者来说，可能仅只能将ARC用在objective-c对象上(也即继承自NSObject的对象)，但是如果涉及到较为底层的东西，比如Core Foundation中的malloc()或者free()等，ARC就鞭长莫及了，这时候还是需要自己手动进行内存管理。在之后我们会看到一些这方面的例子。另外为了确保ARC能正确的工作，有些语法规则也会因为ARC而变得稍微严格一些。</p>
<p>ARC确实可以在适当的地方为代码添加<code>retain</code>或者<code>release</code>，但是这并不意味着你可以完全忘记内存管理，因为你必须在合适的地方把<code>strong</code>指针手动设置到nil，否则app很可能会oom。简单说还是那句话，你必须时刻清醒谁持有了哪些对象，而这些持有者在什么时候应该变为指向<code>nil</code>。</p>
<p>ARC必然是Objective-C以及Apple开发的趋势，今后也会有越来越多的项目采用ARC(甚至不排除MRC在未来某个版本被弃用的可能)，Apple也一直鼓励开发者开始使用ARC，因为它确实可以简化代码并增强其稳定性。可以这么说，使用ARC之后，由于内存问题造成的crash基本就是过去式了(OOM除外 :P)</p>
<p>我们正处于由MRC向ARC转变的节点上，因此可能有时候我们需要在ARC和MRC的代码间来回切换和适配。Apple也想到了这一点，因此为开发这提供了一些ARC和非ARC代码混编的机制，这些也将在之后的例子中列出。另外ARC甚至可以用在C++的代码中，而通过遵守一些代码规则，iOS 4里也可以使用ARC(虽然我个人认为在现在iOS 6都呼之欲出的年代已经基本没有需要为iOS 4做适配的必要了)、</p>
<p>总之，聪明的开发者总会尝试尽可能的自动化流程，已减轻自己的工作负担，而ARC恰恰就为我们提供了这样的好处：自动帮我们完成了很多以前需要手动完成的工作，因此对我来说，转向ARC是一件不需要考虑的事情。</p>
<hr>
<h2>具体操作</h2>
<p>说了这么多，终于可以实践一下了。在决定使用ARC后，很多开发者面临的首要问题是不知如何下手。因为可能手上的项目已经用MRC写了一部分，不想麻烦做转变；或者因为新项目里用ARC时遇到了奇怪的问题，从而放弃ARC退回MRC。这都是常见的问题，而在下面，将通过一个demo引导大家彻底转向ARC的世界。</p>
<h3>Demo</h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWM4LnBuZw==.jpg"></p>
<p>例子很简单，这是一个查找歌手的应用，包含一个简单的UITableView和一个搜索框，当用户在搜索框搜索时，调用<a href="http://musicbrainz.org/" rel="external nofollow noreferrer">MusicBrainz</a>的API完成名字搜索和匹配。MusicBrainz是一个开放的音乐信息平台，它提供了一个免费的XML网页服务，如果对MusicBrainz比较有兴趣的话，可以到它的官网逛一逛。</p>
<blockquote><p>AppDelegate.h/m 这是整个app的delegate，没什么特殊的，每个iOS/Mac程序在main函数以后的入口，由此进入app的生命周期。在这里加载了最初的viewController并将其放到Window中展示出来。另外appDelegate还负责处理程序开始退出等系统委托的事件</p>
<p>MainViewController.h/m/xib 这个demo最主要的ViewController，含有一个TableView和一个搜索条。 SoundEffect.h/m 简单的播放声音的类，在MusicBrainz搜索完毕时播放一个音效。 main.m 程序入口，所有c程序都从main函数开始执行</p>
<p>AFHTTPRequestOperation.h/m 这是有名的网络框架AFNetworking的一部分，用来帮助等简单地处理web服务请求。这里只包含了这一个类而没有将全部的AFNetworking包括进来，因为我们只用了这一个类。完整的框架代码可以在github的相关页面上找到<a href="https://github.com/gowalla/AFNetworking" rel="external nofollow noreferrer">https://github.com/gowalla/AFNetworking</a></p>
<p>SVProgresHUD.h/m/bundle 是一个常用的进度条指示，当搜索的时候出现以提示用户正在搜索请稍后。bundle是资源包，里面包含了几张该类用到的图片，打进bundle包的目的一方面是为了资源容易管理，另一方面也是主要方面时为了不和其他资源发生冲突(Xcode中资源名字是资源的唯一标识，同名字的资源只能出现一次，而放到bundle包里可以避免这个潜在的问题)。SVProgresHUD可以在这里找到<a href="https://github.com/samvermette/SVProgressHUD" rel="external nofollow noreferrer">https://github.com/samvermette/SVProgressHUD</a></p></blockquote>
<p>快速过一遍这个应用吧：<code>MainViewController</code>是<code>UIViewController</code>的子类，对应的xib文件定义了对应的<code>UITableView</code>和<code>UISearchBar</code>。<code>TableView中</code>显示<code>searchResult</code>数组中的内容。当用户搜索时，用AFHTTPRequestOperation发一个HTTP请求，当从MusicBrainz得到回应后将结果放入<code>searchResult</code>数组中并用<code>tableView</code>显示，当返回结果是空时在<code>tableView</code>中显示没找到。主要的逻辑都在MainViewController.m中的<code>-searchBarSearchButtonClicked:</code>方法中，生成了用于查询的URL，根据MusicBrainz的需求替换了请求的header，并且完成了返回逻辑，然后在主线程中刷新UI。整个程序还是比较简单的～</p>
<h3>MRC到ARC的自动转换</h3>
<p>回到正题，我们讨论的是ARC，关于REST API和XML解析的技术细节就暂时先忽略吧..整个程序都是用MRC来进行内存管理的，首先来让我们把这个demo转成ARC吧。基本上转换为ARC意味着把所有的<code>retain</code>,<code>release</code>和<code>autorelease</code>关键字去掉，在之前我们明确几件事情:</p>
<ul>
<li>Xcode提供了一个ARC自动转换工具，可以帮助你将源码转为ARC</li>
<li>当然你也可以自己动手完成ARC转换</li>
<li>同时你也可以指定对于某些你不想转换的代码禁用ARC，这对于很多庞大复杂的还没有转至ARC的第三方库帮助很大，因为不是你写的代码你想动手修改的话代码超级容易mess…</li>
</ul>
<p>对于我们的demo，为了说明问题，这三种策略我们都将采用，注意这仅仅只是为了展示如何转换。实际操作中不需要这么麻烦，而且今后的绝大部分情况应该是从工程建立开始就是ARC的。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWM5LnBuZw==.jpg"></p>
<p>首先，ARC是LLVM3.0编译器的特性，而老的工程特别是Xcode3时代的工程的默认编译器很可能是GCC或者LLVM-GCC，因此第一步就是确认编译器是否正确。<strong>在Project设置面板，选择target，在Build Settings中将Compiler for C/C++/Objective-C选为Apple LLVM compiler 3.0或以上。</strong>为了确保之后转换的顺利，在这里我个人建议最好把Treat Warnings as Errors和 Run Static Analyzer都打开，确保在改变编译器后代码依旧没有警告或者内存问题(虽然静态分析可能不太能保证这一点，但是聊胜于无)。好了～clean(<code>Shift+Cmd+K</code>)以后Bulid一下试试看，经过修改后的demo工程没有任何警告和错误，这是很好的开始。（对于存在警告的代码，这里是很好的修复的时机..请在转换前确保原来的代码没有内存问题）。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMxMC5wbmc=.jpg"></p>
<p>接下来就是完成从MRC到ARC的伟大转换了。还是在Build Settings页面，把Objective-C Automatic Reference Counting改成YES(如果找不到的话请看一看搜索栏前面的小标签是不是调成All了..这个选项在Basic里是不出现的)，这样我们的工程就将在所有源代码中启用ARC了。然后…试着编译一下看看，嗯..无数的错误。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMxMS5wbmc=.jpg"></p>
<p>这是很正常的，因为ARC里不允许出现retain,release之类的，而MRC的代码这些是肯定会有的东西。我们可以手动一个一个对应地去修复这些错误，但是这很麻烦。Xcode为我们提供了一个自动转换工具，可以帮助重写源代码，简单来说就是去掉多余的语句并且重写一些property关键字。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMxMi5wbmc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMxMy5wbmc=.jpg"></p>
<p>这个小工具是Edit-&gt;Refactor下的Convert to Objective-C ARC，点击后会让我们选择要转换哪几个文件，在这里为了说明除了自动转换外的方法，我们不全部转换，而只是选取其中几个转换(<code>MainViewController.m</code>和<code>AFHTTPRequestOperation.m</code>不做转换，之后我们再手动将这两个转为ARC)。注意到这个对话框上有个警告标志告诉我们target已经是ARC了，这是由于之前我们在Build Settings里已经设置了启用ARC，其实直接在这里做转换后Xcode会自动帮我们开启ARC。点击检查后，Xcode告诉我们一个不幸的消息，不能转换，需要修复ARC readiness issues..后面还告诉我们要看到所有的所谓的ARC readiness issues，可以到设置的General里把Continue building after errors勾上…What the f**k…好吧～先乖乖听从Xcode的建议"Cmd+,“然后Continue building after errors打勾然后再build。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMxNC5wbmc=.jpg"></p>
<p>问题依旧，不过在issue面板里应该可以看到所有出问题的代码了。在我们的例子里，问题出在SoundEffect.m里：</p>
<pre><code>NSURL *fileURL = [[NSBundle mainBundle] URLForResource:filename withExtension:nil];
if (fileURL != nil) {
    SystemSoundID theSoundID;
    OSStatus error = AudioServicesCreateSystemSoundID((CFURLRef)fileURL, &amp;theSoundID);
    if (error == kAudioServicesNoError) {
        soundID = theSoundID;
    }
}
</code></pre>
<p>这里代码尝试把一个<code>NSURL</code>指针强制转换为一个<code>CFURLRef</code>指针。这里涉及到一些Core Services特别是Core Foundation(CF)的东西，AudioServicesCreateSystemSoundID()函数接受CFURLRef为参数，这是一个CF的概念，但是我们在较高的抽象层级上所建立的是<code>NSURL</code>对象。在Cocoa框架中，有很多顶层对象对底层的抽象，而在使用中我们往往可以不加区别地对这两种对象进行同样的对待，这类对象即为可以"自由桥接"的对象(toll-free bridged)。NSURL和CFURLRef就是一对好基友好例子，在这里其实<code>CFURLRef</code>和<code>NSURL</code>是可以进行替换的。</p>
<p>通常来说为了代码在底层级上的正确，在iOS开发中对基于C的API的调用所传入的参数一般都是CF对象，而Objective-C的API调用都是传入NSObject对象。因此在采用自由桥接来调用C API的时候就需要进行转换。但是在使用ARC编译的时候，因为内存管理的原因，编译器需要知道对这些桥接对象要实行什么样的操作。如果一个NSURL对象替代了CFURLRef，那么在作用区域外，应该由谁来决定内存释放和对象销毁呢？为了解决这个问题，引入了<strong>bridge,</strong>bridge_transfer和__bridge_retained三个关键字。关于选取哪个关键字做转换，需要由实际的代码行为来决定。如果对于自由桥接机制感兴趣，大家可以自己找找的相关内容，比如<a href="http://developer.apple.com/library/mac/#documentation/CoreFoundation/Conceptual/CFDesignConcepts/Articles/tollFreeBridgedTypes.html%23//apple_ref/doc/uid/20002401-767858" rel="external nofollow noreferrer">适用类型</a>、<a href="http://www.mikeash.com/pyblog/friday-qa-2010-01-22-toll-free-bridging-internals.html" rel="external nofollow noreferrer">内部机制</a>和<a href="http://ridiculousfish.com/blog/posts/bridge.html" rel="external nofollow noreferrer">一个简介</a>～之后我也会对这个问题做进一步说明</p>
<p>回到demo，我们现在在上面的代码中(CFURLRef)前加上<code>__bridge</code>进行转换。然后再运行ARC转换工具，这时候检查应该没有其他问题了，那么让我们进行转换吧～当然在真正转换之前会有一个预览界面，在这里我们最好检查一下转换是不是都按照预想进行了..要是出现大面积错误又没有备份或者出现各种意外的话就可以哭了…</p>
<p>前后变化的话比较简单，基本就是去掉不需要的代码和改变property的类型而已，其实有信心的话不太需要每次都看，但是如果是第一次执行ARC转换的操作的话，我还是建议稍微看一下变化，这样能对ARC有个直观上的了解。检查一遍，应该没什么问题了..需要注意的是main.m里关于autoreleasepool的变化以及所有dealloc调用里的[super dealloc]的删除，它们同样是MRC到ARC的主要变化..</p>
<p>好了～转换完成以后我们再build看看..应该会有一些警告。对于原来<code>retain</code>的property，比较保险的做法是转为<code>strong</code>，在LLVM3.0中自动转换是这样做的，但是在3.1中property默认并不是<code>strong</code>，这样在使用property赋值时存在警告，我们在property声明里加上<code>strong</code>就好了～然后就是SVProgressHUD.m里可能存在问题，这是由于原作者把<code>release</code>的代码和其他代码写在一行了.导致自动转换时只删掉了部分，而留下了部分不应该存在的代码，删掉对变量的空的调用就好了..</p>
<h3>自动转换之后的故事</h3>
<p>然后再编译，没有任何错误和警告了，好棒～等等…我们刚才没有对MainViewController和AFHTTPRequestOperation进行处理吧，那么这两个文件里应该还存在<code>release</code>之类的东西吧..？看一看这两个文件，果然有各种<code>release</code>，但是为什么能编译通过呢？！明明刚才在自动转换前他们还有N多错的嘛…答案很简单，在自动转换的时候因为我们没有勾选这两个文件，因此编译器在自动转换过后为这两个文件标记了"不使用ARC编译"。可以看到在target的Building Phases下，MainViewController.m和AFHTTPRequestOperation.m两个文件后面被加上了<code>-fno-objc-arc</code>的编译标记，被加上该标记的文件将不使用ARC规则进行编译。（相对地，如果你想强制对某几个文件启用ARC的话，可以为其加上<code>-fobjc-arc</code>标记）</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29uZXZjYXQuY29tL2Fzc2V0cy9pbWFnZXMvMjAxMi9hcmNwaWMxNS5wbmc=.jpg"></p>
<p>提供这样的编译标记的原因是显而易见的，因为总是有一部分的第三方代码并没有转换为ARC(可能是由于维护者犯懒或者已经终止维护)，所以对于这部分代码，为了迅速完成转换，最好是使用-fno-objc-arc标记来禁止在这些源码上使用ARC。</p>
<p>为了方便查找，再此列出一些在转换时可能出现的问题，当然在我们使用ARC时也需要注意避免代码中出现这些问题：</p>
<ul>
<li>“Cast … requires a bridged cast”</li>
</ul>
<p><strong><em>这是我们在demo中遇到的问题，不再赘述</em></strong></p>
<ul>
<li>Receiver type ‘X’ for instance message is a forward declaration</li>
</ul>
<p><strong><em>这往往是引用的问题。ARC要求完整的前向引用，也就是说在MRC时代可能只需要在.h中申明@class就可以，但是在ARC中如果调用某个子类中未覆盖的父类中的方法的话，必须对父类.h引用，否则无法编译。</em></strong></p>
<ul>
<li>Switch case is in protected scope</li>
</ul>
<p><strong><em>现在switch语句必须加上{}了，ARC需要知道局部变量的作用域，加上{}后switch语法更加严格，否则遇到没有break的分支的话内存管理会出现问题。</em></strong></p>
<ul>
<li>A name is referenced outside the NSAutoreleasePool scope that it was declared in...</li>
</ul>
<p><strong><em>这是由于写了自己的autoreleasepool，而在转换时在原来的pool中申明的变量在新的@autoreleasepool中作用域将被局限。解决方法是把变量申明拿到pool的申请之前。</em></strong></p>
<ul>
<li>ARC forbids Objective-C objects in structs or unions</li>
</ul>
<p><strong><em>可以说ARC所引入的最严格的限制是不能在C结构体中放OC对象了..因此类似下面这样的代码是不可用的</em></strong></p>
<pre><code>typedef struct {
    UIImage *selectedImage;
    UIImage *disabledImage;
} ButtonImages;
</code></pre>
<p>这个问题只有乖乖想办法了..改变原来的结构什么的..</p>
<h3>手动转换</h3>
<p>刚才做了对demo的大部分转换，还剩下了MainViewController和AFHTTPRequestOperation是MRC。但是由于使用了<code>-fno-objc-arc</code>，因此现在编译和运行都没有问题了。下面我们看看如何手动把MainViewController转为ARC，这也有助于进一步理解ARC的规则。</p>
<p>首先，我们需要转变一下观念…对于MainViewController.h，在.h中申明了两个实例变量：</p>
<pre><code>@interface MainViewController : UIViewController
{
    NSOperationQueue *queue;
    NSMutableString *currentStringValue;
}
</code></pre>
<p>我们不妨仔细考虑一下，为什么在interface里出现了实例变量的申明？通常来说，实例变量只是在类的实例中被使用，而你所写的类的使用者并没有太多必要了解你的类中有哪些实例变量。而对于绝大部分的实例变量，应该都是<code>protected</code>或者<code>private</code>的，对它们的操作只应该用<code>setter</code>和<code>getter</code>，而这正是property所要做的工作。可以说，<strong>将实例变量写在头文件中是一种遗留的陋习</strong>。更好的写实例变量名字的地方应当与类实现关系更为密切，为了隐藏细节，我们应该考虑将它们写在@implementation里。好消息是，在LLVM3.0中，不论是否开启ARC，编译器是支持将实例变量写到实现文件中的。甚至如果没有特殊需要又用了property，我们都不应该写无意义的实例变量申明，因为在@synthesize中进行绑定时，我们就可以设置变量名字了，这样写的话可以让代码更加简洁。</p>
<p>在这里我们对着两个实例变量不需要property(外部成员不应当能访问到它们)，因此我们把申明移到.m里中。修改后的.h是这样的，十分简洁一看就懂～</p>
<pre><code>#import
@interface MainViewController : UIViewController
@property (nonatomic, retain) IBOutlet UITableView *tableView;  
@property (nonatomic, retain) IBOutlet UISearchBar *searchBar; 
@end
</code></pre>
<p>然后.m的开头变成这样：</p>
<pre><code>@implementation MainViewController
{
    NSOperationQueue *queue; 
    NSMutableString *currentStringValue; 
}
</code></pre>
<p>这样的写法让代码相当灵活，而且不得不承认.m确实是这些实例变量的应该在的地方…build一下，没问题..当然对于SoundEffect类也可以做相似的操作，这会让使用你的类的人很开心，因为.h越简单越好..P.S.另外一个好处可以减少.h里的引用，减少编译时间(虽然不明显=。=)</p>
<p>然后就可以在MainViewController里启用ARC了，方法很简单，删掉Build Phases里相关文件的-fno-objc-arc标记就可以了～然后..然后当然是一大堆错误啦。我们来手动一个个改吧，虽然谈不上乐趣，但是成功以后也会很有成就～(如果你不幸在启用ARC后build还是成功了，恭喜你遇到了Xcode的bug，请Cmd+Q然后重新打开Xcode把=_=)</p>
<h4>dealloc</h4>
<p>红色最密集的地方是<code>dealloc</code>，因为每一行都是<code>release</code>。由于在这里<code>dealloc</code>并没有做除了<code>release</code>和<code>super dealloc</code>之外的任何事情，因此简单地把整个方法删掉就好了。当然，在对象被销毁时，<code>dealloc</code>还是会被调用的，因此我们在需要对非ARC管理的内存进行管理和必要的逻辑操作的时候，还是应该保留<code>dealloc</code>的，当然这涉及到CF以及以下层的东西：比如对于<code>retain</code>的CF对象要<code>CFRelease()</code>，对于<code>malloc()</code>到堆上的东西要<code>free()</code>掉，对于添加的<code>observer</code>可以在这里remove，schedule的timer在这里<code>invalidate</code>等等～<code>[super dealloc]</code>这个消息也不再需要发了，ARC会自动帮你搞定。</p>
<p>另外，在MRC时代一个常做的事情是在<code>dealloc</code>里把指向自己的delegate设成nil(否则就等着EXC_BAD_ACCESS吧 :P)，而现在一般delegate都是<code>weak</code>的，因此在self被销毁后这个指针自动被置成<code>nil</code>了，你不用再为之担心，好棒啊..</p>
<h4>去掉各种release和autorelease</h4>
<p>这个很直接，没有任何问题。去掉就行了～不再多说</p>
<h4>讨论一下Property</h4>
<p>在MainViewController.m里的类扩展中定义了两个property：</p>
<pre><code>@interface MainViewController ()
@property (nonatomic, retain) NSMutableArray *searchResults;
@property (nonatomic, retain) SoundEffect *soundEffect; 
@end
</code></pre>
<p>申明的类型是<code>retain</code>，关于<code>retain</code>,<code>assign</code>和<code>copy</code>的讨论已经烂大街了，在此不再讨论。在MRC的年代使用property可以帮助我们使用dot notation的时候简化对象的<code>retain</code>和<code>copy</code>，而在ARC时代，这就显得比较多余了。<del>在我看来，使用property和点方法来调用setter和getter是不必要的。property只在将需要的数据在.h中暴露给其他类时才需要，而在本类中，只需要用实例变量就可以。</del>(更新，现在笔者在这点上已经不纠结了，随意就好，自己明白就行。但是也许还是用点方法会好一些，至少可以分清楚到底是操作了实例变量还是调用了setter和getter)。因此我们可以移去searchResults和soundEffect的@property和@synthesize，并将起移到实例变量申明中：</p>
<pre><code>#import "plementation MainViewController
{ 
    NSOperationQueue *queue; 
    NSMutableString *currentStringValue;
    NSMutableArray *searchResults;
    SoundEffect *soundEffect; 
}
</code></pre>
<p>相应地，我们需要将对应的<code>self.searchResult</code>和<code>self.soundEffect</code>的self.都去去掉。在这里需要注意的是，虽然我们去掉了soundEffect的property和synthesize，但是我们依然有一个lazy loading的方法<code>-(SoundEffect *)soundEffect</code>，神奇之处在于(可能你以前也不知道)，点方法并不需要@property关键字的支持，虽然大部分时间是这么用的..(property只是对setter或者getter的申明，而点方法是对其的调用，在这个例子的实现中我们事实上实现了-soundEffect这个getter方法，所以点方法在等号右边的getter调用是没有问题的)。为了避免误解，建议把self.soundEffect的getter调用改写成[self soundEffect]。</p>
<p>然后我们看看.h里的property～里面有两个<code>retain</code>的IBOutlet。<code>retain</code>关键字在ARC中是依旧可用的，它在ARC中所扮演的角色和<code>strong</code>完全一样。为了避免迷惑，最好在需要的时候将其写为strong，那样更符合ARC的规则。对于这两个property，我们将其申明为<code>weak</code>(事实上，如果没有特别意外，除了最顶层的IBOutlet意外，自己写的outlet都应该是<code>weak</code>)。通过加载xib得到的用户界面，在其从xib文件加载时，就已经是view hierarchy的一部分了，而view hierarchy中的指向都是strong的。因此outlet所指向的UI对象不应当再被hold一次了。将这些outlet写为weak的最显而易见的好处是你就不用再viewDidUnload方法中再将这些outlet设为nil了(否则就算view被摧毁了，但是由于这些UI对象还在被outlet指针指向而无法释放，代码简洁了很多啊..)。</p>
<p>在我们的demo中将IBOutlet的property改为<code>weak</code>并且删掉viewDidUnload中关于这两个IBOutlet的内容～</p>
<p>总结一下新加入的property的关键字类型：</p>
<ul>
<li>strong 和原来的retain比较相似，strong的property将对应__strong的指针，它将持有所指向的对象</li>
<li>weak 不持有所指向的对象，而且当所指对象销毁时能将自己置为nil，基本所有的outlet都应该用weak</li>
<li>unsafe_unretained 这就是原来的assign。当需要支持iOS4时需要用到这个关键字</li>
<li>copy 和原来基本一样..copy一个对象并且为其创建一个strong指针</li>
<li>assign 对于对象来说应该永远不用assign了，实在需要的话应该用unsafe_unretained代替(基本找不到这种时候，大部分assign应该都被weak替代)。但是对于基本类型比如int,float,BOOL这样的东西，还是要用assign。</li>
</ul>
<p>特别地，对于<code>NSString</code>对象，在MRC时代很多人喜欢用copy，而ARC时代一般喜欢用strong…(我也不懂为什么..求指教)</p>
<h4>自由桥接的细节</h4>
<p>MainViewController现在剩下的问题都是桥接转换问题了～有关桥接的部分有三处：</p>
<ul>
<li>(NSString *)CFURLCreateStringByAddingPercentEscapes(…)：CFStringRef至NSString *</li>
<li>(CFStringRef)text：NSString *至CFStringRef</li>
<li>(CFStringRef)@“!_‘();:@&amp;=+$,/?%#[]"：NSString _至CFStringRef</li>
</ul>
<p>编译器对前两个进行了报错，最后一个是常量转换不涉及内存管理。</p>
<p>关于toll-free bridged，如果不进行细究，<code>NSString</code>和<code>CFStringRef</code>是一样的东西，新建一个<code>CFStringRef</code>可以这么做：</p>
<pre><code>CFStringRef s1 = [[NSString alloc] initWithFormat:@"Hello, %@!",name];
</code></pre>
<p>然后，这里<code>alloc</code>了而s1是一个CF指针，要释放的话，需要这样：</p>
<pre><code>CFRelease(s1);
</code></pre>
<p>相似地可以用<code>CFStringRef</code>来转成一个<code>NSString</code>对象(MRC)：</p>
<pre><code>CFStringRef s2 = CFStringCreateWithCString(kCFAllocatorDefault,bytes, kCFStringEncodingMacRoman); 
NSString *s3 = (NSString *)s2; 

// release the object when you're done
[s3 release];
</code></pre>
<p>在ARC中，编译器需要知道这些指针应该由谁来负责释放，如果把一个<code>NSObject</code>看做是CF对象的话，那么ARC就不再负责它的释放工作(记住ARC是only for NSObject的)。对于不需要改变持有者的对象，直接用简单的<strong>bridge就可以了，比如之前在SoundEffect.m做的转换。在这里对于(CFStringRef)text这个转换，ARC已经负责了text这个NSObject的内存管理，因此这里我们需要一个简单的</strong>bridge。而对于<code>CFURLCreateStringByAddingPercentEscapes</code>方法，方法中的create暗示了这个方法将形成一个新的对象，如果我们不需要<code>NSString</code>转换，那么为了避免内存的问题，我们需要使用<code>CFRelease</code>来释放它。而这里我们需要一个<code>NSString</code>，因此我们需要告诉编译器接手它的内存管理工作。这里我们使用<strong>bridge_transfer关键字，将内存管理权由CF object移交给NSObject(或者说ARC)。如果这里我们只用</strong>bridge的话，内存管理的负责人没有改变，那么这里就会出现一个内存泄露。另外有时候会看到<code>CFBridgingRelease()</code>，这其实就是transfer cast的内联写法..是一样的东西。总之，需要记住的原则是，当在涉及CF层的东西时，如果函数名中有含有Create, Copy, 或者Retain之一，就表示返回的对象的retainCount+1了，对于这样的对象，最安全的做法是将其放在<code>CFBridgingRelease()</code>里，来平衡<code>retain</code>和<code>release</code>。</p>
<p>还有一种bridge方式，<code>__bridge_retained</code>。顾名思义，这种转换将在转换时将retainCount加1。和<code>CFBridgingRelease()</code>相似，也有一个内联方法<code>CFBridgingRetain()</code>来负责和<code>CFRelease()</code>进行平衡。</p>
<p>需要注意的是，并非所有的CF对象都是自由桥接的，比如Core Graphics中的所有对象都不是自由桥接的(如<code>CGImage</code>和<code>UIImage</code>，<code>CGColor</code>和<code>UIColor</code>)。另外也不是只有自由桥接对象才能用bridge来桥接，一个很好的特例是void <em>(指向任意对象的指针，类似id)，对于void _和任意对象的转换，一般使用`</em>bridge`。(这在将ARC运用在Cocos2D中很有用)</p>
<h4>终于搞定了</h4>
<p>至此整个工程都ARC了～对于AFHTTPRequestOperation这样的不支持ARC的第三方代码，我们的选择一般都是就不使用ARC了(或者等开源社区的大大们更新ARC适配版本)。可以预见，在近期会有越来越多的代码转向ARC，但是也一定会有大量的代码暂时或者永远保持MRC等个，所以对于这些代码就不用太纠结了～</p>
<hr>
<h2>写在最后</h2>
<p>写了那么多，希望你现在能对ARC有个比较全面的了解和认识了。ARC肯定是以后的趋势，也确实能让代码量大大降低，减少了很多无意义的重复工作，还提高了app的稳定性。但是凡事还是纸上得来终觉浅，希望作为开发者的你，在下一个工程中去尝试用用ARC～相信你会和我一样，马上爱上这种make life easier的方式的～</p>
<p>转载自：https://onevcat.com/</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 23:14:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>手把手教你ARC——iOS/Mac开发ARC入门和使用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LzJmnwp.html" rel="bookmark">手把手教你使J2EE项目开发自动化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				j2ee|项目     编者语:在这本书中,Pragmatic Project Automation, Mike Clark 为你提供了无所不有的方法来自动化你的软件项目:用Ant来一步式构建(one-step builds),用CruiseControl 按计划时间来持续构建(scheduling continuous builds),按一下按钮就可以发布软件,轻易地安装和布署应用,通过email,RSS,你的手机,甚至是熔岩灯(lava lamps)来监控构建和程序运行.方法包含示例使初学者			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV0gYBM.html" rel="bookmark">手把手教你安装QT集成开发环境（操作系统为ubuntu10&period;04）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在安装QT集成开发工具包之前需要先安装build-essential和libncurses5-dev这两个开发工具和库,libncurses5-dev库是一个在Linux/Unix下广泛应用的图形函数库,build-essential里面包括一些Linux下开发的必要工具.在ubuntu中我们使用QT进行开发也用到了这两个工具库.安装命令为:sudo apt-get install build-essential libncurses5-dev. 在这个库安装完成后就可以安装QT开发工具包了,具			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZExnz.html" rel="bookmark">详解iOS应用开发中的ARC内存管理方式&lowbar;IOS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				提示:本文中所说的&quot;实例变量&quot;即是&quot;成员变量&quot;,&quot;局部变量&quot;即是&quot;本地变量&quot; 零.简介ARC是自iOS 5之后增加的新特性,完全消除了手动管理内存的烦琐,编译器会自动在适当的地方插入适当的retain.release.autorelease语句.你不再需要担心内存管理,因为编译器为你处理了一切 注意:ARC 是编译器特性,而不是 iOS 运行时特性(除了weak指针系统),它也不是类似于其它语言中的垃圾收集器.因此 ARC 和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3NK8kz.html" rel="bookmark">手把手教你开发畅销APP的10个步骤！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在短短两年时间里,App Empire首席执行官Chad Mureta创建和销售了三个应用程序公司,获得了数百万美元的收入.他共开发了40多个应用程序,这些程序被下载超过3500万次.在Mureta开发的应用程序中,有90%的应用成功盈利.而且,在开发这些应用程序的过程中,Mureta每周工作不到五个小时. 他是怎么做到这一点呢? Mureta将他的经验总结为如下10个步骤.以下为腾讯科技编译的文章节选. 1.找到市场感觉 在任何领域,你的成功与你对市场的理解直接相关.对于应用程序开发来说,你应			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDnkvKM.html" rel="bookmark">iOS夯实：ARC时代的内存管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS夯实:ARC时代的内存管理 什么是ARC Automatic Reference Counting (ARC) is a compiler feature that provides automatic memory management of Objective-C objects. Rather than having to think about retain and release operations [^1] [^1]: Transitioning to ARC Release			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2YPBvz.html" rel="bookmark">手把手教你写Kconfig---基于tiny4412开发板</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天,我就来教大家写写最简单的Kconfig,什么是Kconfig? 我们配置过的信息最终会在这以下的两个文件中找到. 这个文件会被.c包含 include/generated/autoconf.h  这个autoconf.h中对应的就是一些宏,打开看看就明白了  这个文件根据.config生成,而.config是根据make menuconfig来进行生成,内核中的makefile包含了这个文件inlcude/config/auto.conf    简单的说吧,它是一个Linux驱动的配置文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1l5g3b.html" rel="bookmark">手把手教你发布自己的CocoaPods开源库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是手把手教你发布自己的CocoaPods开源库,发布自己的cocoapods开源库按照以下步骤,良心制作,包教包会!! 下面我会通过一个名为IFMMenu的项目来讲解一下整个过程. 1.写好代码,上传到github github上创建项目仓库的时候记得创建LICENSE(许可证/授权)文件,此文件必须要有. github上创建项目仓库 2.将自己的项目打成tag 因为cocoapods是依赖tag版本的,所以必须打tag,以后再次更新只需要把你的项目打一个tag,然后修改.podspec			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7gNNp.html" rel="bookmark">《iOS应用开发》&mdash;&mdash;1&period;2节启程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 启程 iOS应用开发 无论你去问哪个工匠,他都会说:如果要成功,就必须要有适合工作的工具.对于iOS开发来说,你必须有一台运行OS X 10.7或者更高版本系统的苹果电脑和一份Xcode 4.2.如果你想要在iOS真机设备上运行你的程序,那么你还需要准备一个兼容的设备(iPhone.iPod touch或者iPad),并且还需要有相应的开发证书/供给配置文件(developer/ provisioning profiles).我们将在第3章&quot;应用程序体系结构&quot;一节中进一步阐述供			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p52O5Bz.html" rel="bookmark">《iOS应用开发》&mdash;&mdash;2&period;2节九个基本的程序构建块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 九个基本的程序构建块iOS应用开发我不跟你开玩笑.Objective-C的先前版本学起来非常艰难.一些方面,诸如内存管理,我们只能机械地按照一系列严格的规则来练习.即使是那样,你也很容易出错,导致程序故障.错误以及崩溃.幸运的是,苹果公司持续改进了Objective-C语言并且减少了它的复杂性.因此,我们就只需要花更少的时间驯服程序语言,而有更多的时间来解决实际问题. 然而,如果你之前没有做过任何面向对象编程,那么你可能会有点头大了.有很多需要掌握的新概念:类.对象.子类.父类.重载方法			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBkPJM.html" rel="bookmark" class="title">王通：网络出版赚钱经验谈</a>
					<div>
						网络|赚钱 王通:网络出版赚钱经验谈用传统出版社,我发行了一本印刷版书,从写书到发行,用了一年的心血,仅仅收到了几千元稿费. l 利用互联网发行,我发行的第一本电子书,从写书到发行,用了不到一个月,两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy09kb.html" rel="bookmark" class="title">基于C&num;的接口基础教程之二</a>
					<div>
						第二节 定义接口 从技术上讲,接口是一组包含了函数型方法的数据结构.通过这组数据结构,客户代码可以调用组件对象的功能. 定义接口的一般形式为: [attributes] [modifiers] int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAv1np.html" rel="bookmark" class="title">安全配置和维护Apache WEB Server</a>
					<div>
						apache|server|web|安全 前言:在目前的Internet时代,主页已成为树立公司形象和展示自我天地的一个重要手段,配置一台强大且安全的Web Server就显得尤其重要.在众多的Web ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv3JVp.html" rel="bookmark" class="title">五种类型的互联网创业者&lpar;站长&rpar;</a>
					<div>
						1.门外汉型 中国互联网刚刚发展十年,确诞生了好几家上市公司,这对于传统行业是不可思议的.于是就会有那么一批人出身于传统行业,有一定的资金,抱着&quot;互联网是大势 所趋&quot;的想法投身互联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqewOM.html" rel="bookmark" class="title">PHP程序常见漏洞攻击宝典</a>
					<div>
						程序|攻击 [全局变量] PHP中的变量不需要事先声明,它们会在第一次使用时自动创建,它们的类型也不需要指定,它们会根据上下文环境自动确定.从程序员的角度来看,这无疑是一种极其方便的处理方法.很显然, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk22mEM.html" rel="bookmark" class="title">jsp脚本元素和指令元素和动作指令和内置对象</a>
					<div>
						三个脚本元素: &lt;%! int i=0&gt; 声明变量 &lt;%=a+b%&gt; 表达式 &lt;% if(){ }else{ } %&gt; 脚本段 三个指令元素: &lt;%@ pag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7j4wb.html" rel="bookmark" class="title">如何在Linux下模拟网络环境</a>
					<div>
						linux下模拟网络环境,主要是使用tc命令改写内核信息来模拟网卡收发包的延迟和丢失率. 分为三部分: 1 安装linux系统,可使用redhat5.x企业版,在安装的时候注意勾选&quot;系统网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd72m6M.html" rel="bookmark" class="title">python脚本内运行linux命令的方法</a>
					<div>
						  本文实例讲述了python脚本内运行linux命令的方法.分享给大家供大家参考.具体实现方法如下: ? 1 2 3 4 5 6 7 8 9 #/usr/bin/env python import  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyOnab.html" rel="bookmark" class="title">PS经典合成海边带伞飞翔的仙女</a>
					<div>
						  最终效果 1.打开海边素材,然后使用自由变换工具(CTRL+T)-水平旋转,目的是让他的亮度靠左边. 2.现在我们要对图片左下调整.使用色阶工具(CTRL+L),按下图所示. 3.然后我们在使用曲 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBd48z.html" rel="bookmark" class="title">CPU中三级缓存是什么</a>
					<div>
						  三级缓存是为读取二级缓存后未命中的数据设计的-种缓存,在拥有三级缓存的CPU中,只有约5%的数据需要从内存中调用,这进一步提高了CPU的效率.其运作原理在于使用较快速的储存装置保留一份从慢速储存装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8438p.html" rel="bookmark" class="title">迅雷快鸟加速失败怎么办</a>
					<div>
						  迅雷快鸟加速失败/停止加速解决办法 加速失败原因通常如下 1.加速请求由于各种原因并没有链接到我们的服务器端 2.速器版本不是我们的新版本. 解决办法: 1.下载最新版迅雷快鸟 2.遇到这样的情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EVWdM.html" rel="bookmark" class="title">Nodejs进阶：基于express&plus;multer的文件上传</a>
					<div>
						本文摘录自&lt;Nodejs学习笔记&gt;,更多章节及更新,请访问 github主页地址. 关于作者 正在填坑:&lt;Nodejs学习笔记&gt; / &lt;Express学习笔记&gt; 概 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32JWwz.html" rel="bookmark" class="title">mysql-MySQL数据库表查询优化</a>
					<div>
						问题描述 MySQL数据库表查询优化 假如一个表中有10亿行数据,要查询的数据位置随意,则做一次查询大约需要多久,该怎么样调高查询效率. 解决方案 使用集群吧.如果是单库基本上没什么提高的办法. 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6AKqM.html" rel="bookmark" class="title">在iOS中使用百度地图</a>
					<div>
						就如同在百度地图的文档中所说的一样,这么来.但是,有一个小疏忽. 到添加完所需要的framework之后,一定要记得把你的(Class-Prefix)AppDelegate的后缀改成mm. 估计百度的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAm92M.html" rel="bookmark" class="title">网店代理既便利又无风险</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 以前只听说淘宝上有挣到大钱的,感觉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPaArp.html" rel="bookmark" class="title">android SmartTabLayout&mdash;&mdash;自定义标题带的Android ViewPager</a>
					<div>
						SmartTabLayout是一个自定义Android ViewPager,可以定义ViewPager的标题带,在滑动的时候给用户连续的反馈.   ogaclejapan /  SmartTabLay ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQo0Op.html" rel="bookmark" class="title">open-在VS2013中CFile的file&period;Open 点报错</a>
					<div>
						问题描述 在VS2013中CFile的file.Open 点报错 求教各位,如题 代码如下: /*把位图文件读入内存*/ CFile File;//从CFile类中生成一个实例File if (!Fi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKw2jz.html" rel="bookmark" class="title">显示-关于读取lena图像的灰度值到状态栏的问题</a>
					<div>
						问题描述 关于读取lena图像的灰度值到状态栏的问题 本人小白,最近看了点数字图像的书,为了便于图像的分析,希望把这幅图像的数据信息显示在状态栏上,但显示的时候却出了问题:我想让gray的值为该副图片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBD2oM.html" rel="bookmark" class="title">sql server判断数据库、表、列、视图是否存在&lowbar;MsSql</a>
					<div>
						1 判断数据库是否存在 if exists (select * from sys.databases where name = '数据库名') drop database [数据库名] 2 判断表是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjWKWM.html" rel="bookmark" class="title">IndexedDB简介与入门</a>
					<div>
						   背景 在本地离线存储的场景中,IndexedDB作为一个nosql的本地DB存储一直发挥着重要的作用.在需要存储大量数据时,IndexedDB能够有效地满足你的需求.下面,我将简单介绍下Inde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdR342b.html" rel="bookmark" class="title">vc&plus;&plus;6&period;0、mfc、SQL2005程序打包</a>
					<div>
						问题描述 vc++6.0.mfc.SQL2005程序打包 在vc++6.0上编写的mfc程序,用到数据库SQL2005,请问我怎么可以将程序打包,使它在其他电脑上可以运行?最好是可以打包成安装就可以运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZX0yM.html" rel="bookmark" class="title">Failed during checkstyle execution&colon; Unable to find suppressions file at location&colon; src&sol;checkstyle&sol;checkstyle-suppressions&period;xml</a>
					<div>
						&lt;parent&gt; &lt;groupId&gt;org.springframework.boot&lt;/groupId&gt; &lt;artifactId&gt;spring-boot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyenE4M.html" rel="bookmark" class="title">PV&lpar;访问量&rpar;、UV&lpar;独立访客&rpar;、IP&lpar;独立IP&rpar; （转）</a>
					<div>
						网站统计中的PV(访问量):UV(独立访客):IP(独立IP)的定义与区别今天使用了雅虎统计,看到里面就有这个,就说说,其实里面的uv大家可能觉得很新奇,但是和站长统计里的独立访客是一样的嘛.---- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwP96M.html" rel="bookmark" class="title">请问，可以将excel中的地址，批量导入地图中吗？</a>
					<div>
						问题描述 想找这样一种地图,可以将excel中的地址批量导入到电子地图中.快递公司希望把客户地址标注在地图上,并计算出某个范围内的业务量.请问,可以导入地图吗?可以实现计算一定范围的业务量吗?谢谢.有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqXJdp.html" rel="bookmark" class="title">NetAppCEO称收购DataDomain交易停滞</a>
					<div>
						北京时间6月8日晚间消息,据国外媒体报道,存储巨头NetApp CEO霍浩文(Dan Warmenhoven)上周五称,由于各方都在等待监管机构关于竞争对手EMC竞购Data Domain是否存在反垄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5LLRz.html" rel="bookmark" class="title">关于div自适应高度&sol;左右高度自适应一致的js代码&lowbar;javascript技巧</a>
					<div>
						在使用DIV和CSS进行网页布局中,DIV的自适应高度和自适应宽度是一个很常见的问题. 为了保证页面的整体美观性,需要将两个或者多个层的高度/宽度保持一致. 左右自适应高度一致 Jquery 复制代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxELx0p.html" rel="bookmark" class="title">c&num;调用百度短网址api</a>
					<div>
						问题描述 byte[]postData=Encoding.UTF8.GetBytes(&quot;url=http://bbs.csdn.net/topics/new?forum_id=ASPDotN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4YLWNb.html" rel="bookmark" class="title">大亚科技陷担保怪圈巨额担保让人忧</a>
					<div>
						继7月7日大亚科技(000910,收盘价7.67元)股东大会通过向大股东及关联方提供总计15.83亿对外担保后,昨日(7月21日)大亚科技又发公告称,公司还将向大股东及关联方提供2.3亿对外担保,这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWjl8M.html" rel="bookmark" class="title">这个市场绝不能少！</a>
					<div>
						摘要: 张艺谋说过,一个都不能少,这句话是否要被Facebook实现了?没错,中国的市场绝对不能少! 根据知情人士向彭博社透露,Facebook在北京金融街租下了一个800平米的地方作为销售办公室 张 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBkAZb.html" rel="bookmark" class="title">cunit-怎样在window环境下安装Cunit单元测试框架</a>
					<div>
						问题描述 怎样在window环境下安装Cunit单元测试框架 请教大神,Cunit单元测试框架的库文件怎么编译,怎样把Cunit添加到VC工程?谢谢.					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.050 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
